//+------------------------------------------------------------------+
//|                                          Perevertysh20240503.mq5 |
//|                                                          Voronin |
//|                                      Virtual Trailing Stop 2.mq5 |
//|                              Copyright © 2020, Vladimir Karputov |
//|                     https://www.mql5.com/ru/market/product/43516 |
//|                                           http://wmua.ru/slesar/ |
//|                                                           Gerbut |
//|                                           andriygerbut@gmail.com |
//+------------------------------------------------------------------+
#property version   "1.00"
#property version   "1.000"
#property strict

// Libraries:
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
//#include <SecAuxLib.mqh>
#include <MT4Orders.mqh>

CPositionInfo k_pos;
CSymbolInfo       m_symbol;
CTrade            m_trade;

//+------------------------------------------------------------------+
// Input parameters:
//+------------------------------------------------------------------+
enum ENUM_SYMBOL
{
    EURUSD  = 0,
    GPBUSD  = 1,
    USDCHF  = 2,
    BTCUSD  = 3,
    USDCAD  = 4,
    AUDCAD  = 5,
    NAZUSD  = 6,
    AUDCHF  = 7,
    AUDJPY  = 8,
    AUDUSD  = 9,
    BITCOIN = 10,
    XAUUSD  = 11,
    XAGUSD  = 12
};
input       ENUM_SYMBOL SYMBOL;
input       ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
input       double LotSize            = 0.01; 
input       ulong  Magic_m            = 9191;        // M1-9991,H1-9960,H4-9240,D1-1440,perevertysh-9191
input ulong InpDeviation              = 10;          // Deviation, in points (1.00045-1.00055=10 points)
//+------------------------------------------------------------------+
double   ask                          = SymbolInfoDouble(Symbol(), SYMBOL_ASK);
double   bid                          = SymbolInfoDouble(Symbol(), SYMBOL_BID);
long     spred                        = SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
double   Tick_Size                    = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_SIZE); // минимально возможное изменение цены
ulong    m_position_ticket            = 0;
ulong    ClosedTicket                 = 0;
MqlTradeRequest m_request;                            // структура торгового запроса
MqlTradeResult m_result;                              // структура результата торгового запроса
double   m_adjusted_point;                            // point value adjusted for 3 or 5 points
ulong    MS                           = 1000;
ulong    TFMS                         = PeriodSeconds(/*Period()*/ PERIOD_M1) * MS;

//+------------------------------------------------------------------+
// Methods-Events:                                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   m_trade.SetExpertMagicNumber(Magic_m);
   if(!m_symbol.Name(Symbol()))                                                 // sets symbol name
     {
      Print(__FILE__," ",__FUNCTION__,", ERROR: CSymbolInfo.Name");
      return(INIT_FAILED);
     }
   RefreshRates();
//---
   m_trade.SetMarginMode();
   m_trade.SetTypeFillingBySymbol(m_symbol.Name());
   m_trade.SetDeviationInPoints(InpDeviation);

   m_adjusted_point             = Tick_Size;                                     //m_symbol.Point()*digits_adjust;
//---
        EventSetMillisecondTimer(300);
        return (INIT_SUCCEEDED);
}
    
void OnTick()
{
   OnTimer();
}

void OnTimer()
{
   /*int         total            = PositionsTotal();
   for(int i=total-1; i>=0; i--)
   {
      k_pos.SelectByIndex(i);
      mposition_ticket = PositionGetTicket(i);
      string m_position_symbol       = k_pos.Symbol();
      long   m_position_magic        = k_pos.Magic();
      Print("total = ",(string)total,", mposition_ticket = ",(string)mposition_ticket,", m_position_magic = ",(string)m_position_magic);*/
        MqlTradeRequest tradeRequest = { };
        MqlTick last_tick;
        MqlTick current_tick;
        SymbolInfoTick(Symbol(),last_tick);
        SymbolInfoTick(Symbol(),current_tick);
        double ask0             = current_tick.ask;                               //SymbolInfoDouble(Symbol(), SYMBOL_ASK);
        double bid0             = current_tick.bid;
        ulong  time0            = current_tick.time_msc;
        ulong  timeOpen         = PositionGetInteger(POSITION_TIME_MSC);
        ENUM_POSITION_TYPE Type = (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE); // тип позиции
        double Price            = PositionGetDouble(POSITION_PRICE_OPEN);
        double Tp               = PositionGetDouble(POSITION_TP);
        m_position_ticket       = PositionGetInteger(POSITION_TICKET);
        double lt               = PositionGetDouble(POSITION_VOLUME);              // объем позиции
        ulong  magic            = PositionGetInteger(POSITION_MAGIC); // MagicNumber позиции

MqlTick ticks[];
MqlTick tick;
SymbolInfoTick(Symbol(),tick);
  MqlTick mqlTick[], symbTick; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick); // это последний тик
  CopyTicksRange(_Symbol, mqlTick, COPY_TICKS_INFO, symbTick.time_msc, symbTick.time_msc-300); // цены за последний период
  for(int i = 0; i < ArraySize(mqlTick); i++)
  {
     double bid1 = NormalizeDouble(mqlTick[0].bid, _Digits); // первая цена bid за последний период
     double ask1 = NormalizeDouble(mqlTick[0].ask, _Digits); // первая цена ask за последний период

      //if(total == 0 || !(mposition_ticket > 0 && m_position_symbol == _Symbol && m_position_magic == Magic_m))*/ // Нет позиций по инструменту и эксперту
      if(!PositionSelect(Symbol())) // Нет открытых позиций
        {
            Print("Нет открытых позиций");
            if(spred > 4 && bid0 > ask0)
            {
                m_trade.Buy(LotSize,Symbol(),bid0,NULL,NULL,NULL);
                Print("1бай, spred > 4 && bid0 > ask0");
            }
            if(spred > 4 && ask0 > bid0)
            {
                m_trade.Sell(LotSize,Symbol(),ask0,NULL,NULL,NULL);
                Print("2селл, spred > 4 && ask0 > bid0");
            }
            if(spred <= 4 && ask0 > ask1 && bid0 > bid1)
            {
               m_trade.Buy(LotSize,Symbol(),bid0,NULL,NULL,NULL);
               Print("3бай, spred <= 4 && ask0 > ask1 && bid0 > bid1");
            }
            if(spred <= 4 && ask0 < ask1 && bid0 < bid1)
            {
               m_trade.Sell(LotSize,Symbol(),ask0,NULL,NULL,NULL);
               Print("4селл, spred <= 4 && ask0 < ask1 && bid0 < bid1");
            }
        }
        if(PositionSelect(Symbol())) // Есть открытые ордера
        {
            Print("Есть открытые ордера");
            if(Type == POSITION_TYPE_BUY && (bid0 > Price))
            {
               Print("1POSITION_TYPE_BUY && (bid0 > Price)");
               if(m_trade.PositionClose(m_position_ticket)) Print("1закрыли");
            }
            if(Type == POSITION_TYPE_SELL && (ask0 > Price))
            {
               Print("2POSITION_TYPE_SELL && (ask0 > Price)");
               if(m_trade.PositionClose(m_position_ticket)) Print("2закрыли");
            }
            if(Type == POSITION_TYPE_BUY && (bid0 < bid1 && ask0 < ask1))
            {
               Print("3POSITION_TYPE_BUY && (bid0 < bid1 && ask0 < ask1)");
               if(m_trade.PositionClose(m_position_ticket)) Print("3закрыли");
            }
            if(Type == POSITION_TYPE_SELL && (ask0 > ask1 && bid0 > bid1))
            {
               Print("4POSITION_TYPE_SELL && (ask0 > ask1 && bid0 > bid1)");
               if(m_trade.PositionClose(m_position_ticket)) Print("4закрыли");
            }
        }
     }
}

//+------------------------------------------------------------------+
//| Refreshes the symbol quotes data                                 |
//+------------------------------------------------------------------+
bool RefreshRates(void)
  {
   if(!m_symbol.RefreshRates())
     {
      Print("RefreshRates error");
      return(false);
     }
//--- protection against the return value of "zero"
   if(m_symbol.Ask()==0 || m_symbol.Bid()==0)
      return(false);
//---
   return(true);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();
}
